zoukankan      html  css  js  c++  java
  • HDU 3038 How Many Answers Are Wrong(带权并查集,真的很难想到是个并查集!!!)

    How Many Answers Are Wrong

    Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
    Total Submission(s): 14546    Accepted Submission(s): 5125


    Problem Description
    TT and FF are ... friends. Uh... very very good friends -________-b

    FF is a bad boy, he is always wooing TT to play the following game with him. This is a very humdrum game. To begin with, TT should write down a sequence of integers-_-!!(bored).

    Then, FF can choose a continuous subsequence from it(for example the subsequence from the third to the fifth integer inclusively). After that, FF will ask TT what the sum of the subsequence he chose is. The next, TT will answer FF's question. Then, FF can redo this process. In the end, FF must work out the entire sequence of integers.

    Boring~~Boring~~a very very boring game!!! TT doesn't want to play with FF at all. To punish FF, she often tells FF the wrong answers on purpose.

    The bad boy is not a fool man. FF detects some answers are incompatible. Of course, these contradictions make it difficult to calculate the sequence.

    However, TT is a nice and lovely girl. She doesn't have the heart to be hard on FF. To save time, she guarantees that the answers are all right if there is no logical mistakes indeed.

    What's more, if FF finds an answer to be wrong, he will ignore it when judging next answers.

    But there will be so many questions that poor FF can't make sure whether the current answer is right or wrong in a moment. So he decides to write a program to help him with this matter. The program will receive a series of questions from FF together with the answers FF has received from TT. The aim of this program is to find how many answers are wrong. Only by ignoring the wrong answers can FF work out the entire sequence of integers. Poor FF has no time to do this job. And now he is asking for your help~(Why asking trouble for himself~~Bad boy)
     
    Input
    Line 1: Two integers, N and M (1 <= N <= 200000, 1 <= M <= 40000). Means TT wrote N integers and FF asked her M questions.

    Line 2..M+1: Line i+1 contains three integer: Ai, Bi and Si. Means TT answered FF that the sum from Ai to Bi is Si. It's guaranteed that 0 < Ai <= Bi <= N.

    You can assume that any sum of subsequence is fit in 32-bit integer.
     
    Output
    A single line with a integer denotes how many answers are wrong.
     
    Sample Input
    10 5 1 10 100 7 10 28 1 3 32 4 6 41 6 6 1
     
    Sample Output
    1
     
    Source
     
    Recommend
    gaojie   |   We have carefully selected several similar problems for you:  3033 3035 3036 3037 3031 
     
    给出n,m,下面m行每一行有三个数,a,b,v,v代表的是区间【a,b】的和,每一行都是这样,但是当第i行与前i-1行发生冲突的时候,记录一下。输出共错误多少句。举个例子:第一行是 1 100 200,第二行是1 50 300,这就发生了冲突。
     
     
     假设用dis代表距离,那么dis(a-b)=v;但是前i-1行不一定有一模一样的a,b,v,所以就要借助一个过渡,假设是c,那么就可以这样:dis(a-c)-dis(b-c)=v,有没有发现如果我们把他们共同的根节点也就是祖先,当做c的话,只需要知道节点a到祖先的距离,节点b到祖先的距离,就可以知道a和b的距离了(假设他们有共同的祖先),那如果a和b没有共同的祖先,那么在之前就找不到他们俩的关系,就不能确定dis(a-b)=v这个关系为假。就可以把他们的父节点连在一起,即把他俩各自的祖先弄到一起,比如把a的祖先拿去给b的祖先当父亲。
     
     
     

    现在用sum[k]表示 k 到 k基准(k的根节点) 的距离.

    如果想合并a, b,最终目的是求a,b,到其共同基准的距离.首先求出a, b的祖宗,即比较标准x, y,默认x认y为爹,(a的祖先认b的祖先为爹)所以a的祖先变成了y, x的祖先变成了y,所以a到a的祖先的距离(a到y)=(a到x) + (x 到y),, b到y的距离即为sum[b]没变; 
    下面推倒,如图
    1:sum[a] = v + k;
    2:sum[b] = k + (y-x);
    2-1: y-x = sum[b] - sum[a] + v;
    从而另sum[x] = sum[b] - sum[a] + v; 而后更新sum[a].更新的部分放在了查找中.

    需要重点注意的地方标记了感叹号!!!

    code:

    #include<queue>
    #include<set>
    #include<cstdio>
    #include <iostream>
    #include<algorithm>
    #include<cstring>
    #include<cmath>
    #include<map>
    #include<string>
    #include<string.h>
    #include<memory>
    using namespace std;
    #define max_v 200005
    #define INF 9999999
    int pa[max_v];
    int sum[max_v];
    int n,m;
    int ans;
    void init()
    {
        for(int i=0;i<=n;i++)
        {
            pa[i]=i;
            sum[i]=0;
        }
    }
    int find_set(int x)
    {
        if(pa[x]!=x)
        {
            int t=pa[x];
            pa[x]=find_set(pa[x]);
            sum[x]+=sum[t];//!!!
        }
        return pa[x];
    }
    void union_set(int a,int b,int v)
    {
        int x=find_set(a);
        int y=find_set(b);
        if(x==y)
        {
            if(sum[a]-sum[b]!=v)//!!!
                ans++;
        }else
        {
            pa[x]=y;
            sum[x]=sum[b]-sum[a]+v;//!!!
        }
    }
    int main()
    {
        while(~scanf("%d %d",&n,&m))
        {
            int x,y,w;
            ans=0;
            init();
            for(int i=0;i<m;i++)
            {
                scanf("%d %d %d",&x,&y,&w);
                x--;//!!!
                union_set(x,y,w);
            }
            printf("%d
    ",ans);
        }
        return 0;
    }
     
  • 相关阅读:
    硬核动图让你轻松弄懂递归,查找等概念
    Instagram API平台文档
    盲人都能编程,你有什么资格说自己不行
    10个经典智力推理题!据说答对7道,智力在140!
    我们该如何高效的学习
    从一碗小米粥谈装饰器模式,代理模式的区别
    html+css实现彩色渐变滑动条
    css实现彩色渐变滑动条
    [极客大挑战 2019]Knife 思路
    buuctf
  • 原文地址:https://www.cnblogs.com/yinbiao/p/9460772.html
Copyright © 2011-2022 走看看